#Biomatematyka - Cwiczenia 1 -Wstęp do R
#Aby uruchomic linie kodu ustawiamy kursor na poczatku linii i naciskamy Ctrl+Enter
#Aby uruchomic caly skrypt nacisnij Ctrl+Shift+Enter
#Instrukcja: Wywołuj oddzielnie linie kodu
#Przy poleceniach zapisuj kod ponizej polecenia
# znak ";" oddziela polecenia w jednej linijce

################# Zaczynamy! ##########################

#Jaki mamy dzisiaj dzien? - Przykład wbudowanej funkcji
date()

#Oblicz wartosc e (stala wykladnicza) do potegi 5 - Przyklad wbudowanej funkcji z jednym argumentem
exp(5)

#Pomocy!
help.start()        #manual
help(sum)           #pomoc dotycząca funkcji
?sum                #pomoc dotycząca funkcji, wynik taki jak wyżej
apropos("sum")      #wyświetla wszystkie funkcje zawierajace slowo "sum"
example(sum)        #wyświetla przyklad użycia danej funkcji - o ile jest dostępny

##########################################################
#################### A. KalkuRator i zmienne ##############
##########################################################

#Wywolaj ponizsze linie kodu
#To jest komentarz!
"To jest tekst"

a<-"To jest tekst"

# WAŻNE! Funkcja str() zwraca typ zmiennej
str(a)

# To jest typ logiczny
TRUE
a<-TRUE
a<-T
str(a)

FALSE
b<-FALSE
str(b)

# To jest typ liczbowy
2.456
c<-2.456
str(c)

# R działa jak kalkulator
1+3

# Obliczamy sume 1 i 3 i zapisujemy wynik pod zmienna a
a=1+3

# inny zapis - "<-" to tradycyjny operator przypisania
a<-1+3

# Podanie nazwy zmiennej powoduje wyświetlenie jej zawartości w konsoli
a

### Zadania A
# 1.Jaki typ ma zmienna a?

# 2.Oblicz logarytm dziesiętny z 20 - funkcja log10()

# 3.Oblicz pierwiastek kwadratowy z 452 - funckja sqrt()

# 4.Oblicz wielkość populacji bakterii w 10 godzinie dla lambda = 1.6, jezeli ich poczatkowa liczebnosc jest rowna 5
#   Zapisz wynik pod zmienną N_k
#   Rownanie - wzrost geometryczny: N_k=N0*lambda^k


# 5.Zapisz poczatkowa liczebność populacji pod zmienna "N0", czas pod zmienna "k"
#   a wspolczynnik wzrostu populacji pod zmienna "lambda". Zapisz rownanie jeszcze raz.
#   Wynik zapisz pod zmienna N_k

####################################################################
######################## B. Pakiety i dane ##########################
####################################################################

#Korzystajac z pakietu R mamy dostep do zbiorow danych testowych
#aby wyswietlic aktualnie dostepne wpisujemy data()
data()

library()     #sprawdzamy jakie pakiety sa obecnie zainstalowane

#Dodatkowe zbiory danych oraz funkcje sa dostepne po instalacji pakietow
library(MASS)   #wczytaj pakiet MASS, pakiet musi byc wczytany aby zaladowac funkcje i dane
# install.packages("MASS")   #zainstaluj pakiet MASS je?eli nie jest dostepny

###Zadania B:
#1. Sprawdz czy zainstalowany jest pakiet DAAG!

#2. Wyświetl bazę litters - musi być wczytany pakiet DAAG


############################################################
#################### C. WektoRy #############################
############################################################

#Przyklad 1 - kilka sposobow na stworzenie wektora zawierajacego liczby od 1 do 10

c(1,2,3,4,5,6,7,8,9,10)
c(1:10)
seq(1,10,1)

#Przyklad 2 - wektor z sekwencja od 1 do 3 powtorzona 5 razy
rep(c(1:3),5)

### Zadania C
#1. Stworz wektor z liczbami od 1 do 20 i zapisz go pod zmienna "czas"

#2. Posortuj zawartosc wektora malejaco i zapisz pod zmienna "czas_sort"
#   skorzystaj z pomocy aby dowiedziec sie jak posortowac malejaco

#3. Stworz wektor zawierajacy liczby od 1 do 10 co 0.5 i zapisz pod zmienna "czas_dokladny"

############################
#  Dzialania na wektorach  #
############################

#4. Pomnoz czas_sort przez czas_dokladny i zapisz wynik pod zmienna "iloczyn"
#   pytanie pomocnicze: dlaczego program wyswietlil ostrzezenie i czym różni się ono od bledu?


#5. Oblicz sume dla wektora czas


#6. Podnies wszystkie elementy wektora czas do potegi 3 i zapisz pod nazwa czas_potega


############################
#  Indeksowanie wektorow   #
############################

###Przyklady:
wektor<-c(1:20)

wektor[15]  #zwraca 15 element powstalego wektora
wektor[-7]  #zwraca wszystkie elementy wektora poza 7
wieksze<-wektor[wektor>15]    #wybiera elementy wektora wieksze od 15 i zapisuje pod zmienna "wieksze"

# Wczytaj pakiet
library(MASS)
size<-mammals$body #wektor z informacjami o sredniej masie ciala [kg] roznych gatunkow ssakow

### Zadania
#7. Zwroc 17 element wektora size

#8. Wybierz zwierzeta cięższe niz 100 kg i zapisz pod zmienna "duze"

#9. Ile zwierzat w bazie ma mase ciala wieksza niz 100kg?

#10. Uzyj fukcji summary() dla wektora size. Jaki jest wynik?

##############################################################
######################## D. Funkcje ###########################
##############################################################

#Przyklad funkcji z jednym argumentem
#Funkcja, ktora dodaje 4 do wartosci podanej jako argument
dodawanie<-function(x){x+2}
a<-4
dodawanie(a) #wywolujemy funkcje

#Przyklad funkcji z wiecej niz jednym argumentem
#Srednia z dwoch podanych wartosci
srednia<-function(a,b){
  srednia<-(a+b)/2
  return(srednia)
  }
srednia(5,8) #przyklad użycia
#a i b sa argumentami funkcji

### Zadanie D
#1. Stworz funkcje ktora oblicza indeks BMI - waga[kg] dzielona przez wzrost[m] do kwadratu
#   Uzyj funkcji na wymyślonych danych

#2. Stworz funkcje na podstawie zadania 4 z części A. Funkcja powinna zwracać przewidziany stan populacji w czasie t.
# Argumenty: r, t, N0
# Wynik: Nt
# Nazwa funkcji: wzrost


############################################################
######################## E. Ramki danych ####################
############################################################

#Tworzy ramki danych i zapisuje pod zmienna dane
dane=data.frame(ID=1:5,plec=c("M","F","F","M","F"),wzrost=c(185,172,162,178,159))

#To samo, najpierw tworząc wektory
plec=c("M","F","F","M","F")
wzrost=c(185,172,162,178,159)
dane=data.frame(plec,wzrost)             

dane        # wyświetli ramke danych w konsoli
View(dane)  # wyświetli ramke danych w formacie arkusza kalkulacyjnego
head(dane)  # wyświetli pierwsze kilka wierszy tabeli
tail(dane)  # wyświetli ostatnie kilka wierszy tabeli

# Struktura utworzonego obiektu
str(dane)       # Jakiego typu sa dane w poszczegolnych kolumnach

# Podsumowanie dla wszystkich zmiennych w tabeli
summary(dane)

# Nazwy kolumn oraz nazwy wierszy
colnames(dane)
rownames(dane)

# Indeksowanie
dane$wzrost    # odwołujemy się do kolumny wzrost
dane[,2]       # odwołujemy się do kolumny 2
dane$wzrost[5] # 5 wiersz z kolumny o nazwie wzrost
dane[3,2]      # Trzeci wiersz, druga kolumna

### Zadania E
# 1. Odwołaj się do drugiej kolumny bazy mammals i zapisz pod zmienną wzrost

# 2. Odwołaj się do 3 wiersza i 2 kolumny w tabeli mammals

# 3. Wyświetl dane dla wiersza 19 i napisz jakiego gatunku dotyczy?


#############################################################
########## Dodatek F - Wczytywanie plikow csv i txt ##########
#############################################################

#Katalog roboczy to lokalizacja w ktorej program automatycznie zapisuje nasze dane i szuka danych wejsciowych
#Katalog roboczy wyznaczamy z menu Session > Set working directory > choose directory
#lub komenda setwd(), przyklad:

setwd("c:\\Users\\student\\Documents\\R_pliki\\")

#Kopiujemy sciezke do naszego katalogu
#Jezeli pracujemy w systemie Windows ukosniki musza byc podwojne jak w przykladzie powyzej!

###Zadania:
#Ustaw katalog roboczy na folder w ktorym aktualnie pracujesz, w ktorym znajduja sie wszystkie pliki.


#Aby zaimportowac dane do R musza znajdowac sie w naszym katalogu roboczym
#lub uwzgledniamy sciezki razem z nazwa pliku

#Uzywamy funkcji read.table(), przyklad:
dane <- read.table("mojedane.txt", header=TRUE, sep="\t", row.names=1)

#Jezeli nasze dane maja naglowki argument header=TRUE, jezeli nie FALSE
#Jezeli nasze dane maja nazwy wierszy argument row.names=1
#Argument sep to separator, ktory oddziela dane z roznych kolumn np. "," ";" " " "\t"

#Wczytujac dane z excela uzywamy funkcji:
#dane przedzielone przecinkami "," a kropka dziesietna jest "."- read.csv()
#dane przedzielone srednikami ";" a kropka dziesietna jest "," - read.csv2()
#Plik w excelu zapisujemy w formacie .csv poprzez zapisz jako
#przyklad:
dane<-read.csv("nazwa_pliku.csv",header=TRUE,row.names=1)

### Ćwiczenie do domu:
#Zaladuj pliki tv.txt, dzieci.txt oraz woda.csv do R i zapisz je pod zmiennymi wg nazwy pliku


